﻿'(C) Copyright 2011 by Autodesk, Inc. 

'Permission to use, copy, modify, and distribute this software
'in object code form for any purpose and without fee is hereby
'granted, provided that the above copyright notice appears in
'all copies and that both that copyright notice and the limited
'warranty and restricted rights notice below appear in all
'supporting documentation.

'AUTODESK PROVIDES THIS PROGRAM "AS IS" AND WITH ALL FAULTS. 
'AUTODESK SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF
'MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE.  AUTODESK,
'INC. DOES NOT WARRANT THAT THE OPERATION OF THE PROGRAM WILL
'BE UNINTERRUPTED OR ERROR FREE.

'Use, duplication, or disclosure by the U.S. Government is
'subject to restrictions set forth in FAR 52.227-19 (Commercial
'Computer Software - Restricted Rights) and DFAR 252.227-7013(c)
'(1)(ii)(Rights in Technical Data and Computer Software), as
'applicable.

Imports System
Imports System.Type
Imports System.Activator
Imports System.Runtime.InteropServices
Imports Inventor

Public Class Form1
  Dim _invApp As Inventor.Application
  Dim _started As Boolean = False

  Public Sub New()

    ' This call is required by the designer.
    InitializeComponent()

    ' Add any initialization after the InitializeComponent() call.
    Try
      _invApp = Marshal.GetActiveObject("Inventor.Application")

    Catch ex As Exception
      Try
        Dim invAppType As Type = _
          GetTypeFromProgID("Inventor.Application")

        _invApp = CreateInstance(invAppType)
        _invApp.Visible = True

        'Note: if you shut down the Inventor session that was started
        'this(way) there is still an Inventor.exe running. We will use
        'this Boolean to test whether or not the Inventor App  will
        'need to be shut down.
        _started = True

      Catch ex2 As Exception
        MsgBox(ex2.ToString())
        MsgBox("Unable to get or start Inventor")
      End Try
    End Try

  End Sub

  Private Sub Form1_FormClosed( _
  ByVal sender As Object, ByVal e As FormClosedEventArgs) _
  Handles Me.FormClosed

    If _started Then
      _invApp.Quit()
    End If

    _invApp = Nothing

  End Sub

  Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
    'Add code for Lesson 1 here

    If _invApp.Documents.Count = 0 Then
      MsgBox("Need to open an Assembly document")
      Return
    End If

    If _invApp.ActiveDocument.DocumentType <> _
    DocumentTypeEnum.kAssemblyDocumentObject Then
      MsgBox("Need to have an Assembly document active")
      Return
    End If

    Dim asmDoc As AssemblyDocument
    asmDoc = _invApp.ActiveDocument

    If asmDoc.SelectSet.Count = 0 Then
      MsgBox("Need to select a Part or Sub Assembly")
      Return
    End If

    Dim selSet As SelectSet
    selSet = asmDoc.SelectSet

    Try
      Dim compOcc As ComponentOccurrence
      Dim obj As Object
      For Each obj In selSet
        compOcc = obj
        Debug.Print(compOcc.Name)
        compOcc.Visible = False
      Next
    Catch ex As Exception
      MsgBox("Is the selected item a Component?")
      MsgBox(ex.ToString())
      Return
    End Try



  End Sub
End Class
